diff --git a/docs/descriptors/8bitso_sn30_windows.md b/docs/descriptors/8bitso_sn30_windows.md
index 718aab4..7783099 100644
--- a/docs/descriptors/8bitso_sn30_windows.md
+++ b/docs/descriptors/8bitso_sn30_windows.md
@@ -185,7 +185,19 @@ Converted to tables of report IDs:
 TBD
 ```
 
-Button bitmap:
+Button bitmap (extracted from `btmon`):
 ```
-TBD
+ID -- -- -- -- -- -- -- -- -- -- -- -- Buttons
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 01 00 - B 0000 0001 = 90001
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - B 0000 0001
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 02 00 - A 0000 0010 = 90002
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - A 0000 0010
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 04 00 - Y 0000 0100 = 90003
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - Y 0000 0100
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 08 00 - X 0000 1000 = 90004
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - X 0000 1000
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 10 00 - L 0001 0000 = 90005 (shoulder)
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - L 0001 0000
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 20 00 - R 0010 0000 = 90006 (shoulder)
+01 00 80 00 80 00 80 00 80 00 00 00 00 00 00 00 - R 0010 0000
 ```
diff --git a/hid-xpadneo/src/hid-xpadneo.c b/hid-xpadneo/src/hid-xpadneo.c
index 037dc1b..7c5d709 100644
--- a/hid-xpadneo/src/hid-xpadneo.c
+++ b/hid-xpadneo/src/hid-xpadneo.c
@@ -81,6 +81,7 @@ MODULE_PARM_DESC(gamepad_compliance,
 #define XPADNEO_QUIRK_NO_MOTOR_MASK     4
 #define XPADNEO_QUIRK_USE_HW_PROFILES   8
 #define XPADNEO_QUIRK_LINUX_BUTTONS     16
+#define XPADNEO_QUIRK_NINTENDO          32
 
 static struct {
 	char *args[17];
@@ -94,7 +95,8 @@ MODULE_PARM_DESC(quirks,
 		 ", no trigger rumble = " __stringify(XPADNEO_QUIRK_NO_TRIGGER_RUMBLE)
 		 ", no motor masking = " __stringify(XPADNEO_QUIRK_NO_MOTOR_MASK)
 		 ", hardware profile switch = " __stringify(XPADNEO_QUIRK_USE_HW_PROFILES)
-		 ", use Linux button mappings = " __stringify(XPADNEO_QUIRK_LINUX_BUTTONS));
+		 ", use Linux button mappings = " __stringify(XPADNEO_QUIRK_LINUX_BUTTONS)
+		 ", use Nintendo mappings = " __stringify(XPADNEO_QUIRK_NINTENDO));
 
 static DEFINE_IDA(xpadneo_device_id_allocator);
 
@@ -194,7 +196,7 @@ struct quirk {
 static const struct quirk xpadneo_quirks[] = {
 	DEVICE_OUI_QUIRK("E4:17:D8",
 			 XPADNEO_QUIRK_NO_PULSE | XPADNEO_QUIRK_NO_TRIGGER_RUMBLE |
-			 XPADNEO_QUIRK_NO_MOTOR_MASK),
+			 XPADNEO_QUIRK_NO_MOTOR_MASK | XPADNEO_QUIRK_NINTENDO),
 };
 
 struct usage_map {
@@ -862,6 +864,8 @@ static void xpadneo_switch_profile(struct xpadneo_devdata *xdata, const u8 profi
 	xdata->profile_switched = emulated;
 }
 
+#define SWAP_BITS(v,b1,b2) \
+	(((v)>>(b1)&1)==((v)>>(b2)&1)?(v):(v^(1ULL<<(b1))^(1ULL<<(b2))))
 static int xpadneo_raw_event(struct hid_device *hdev, struct hid_report *report,
 			     u8 *data, int reportsize)
 {
@@ -890,6 +894,12 @@ static int xpadneo_raw_event(struct hid_device *hdev, struct hid_report *report,
 		data[16] = 0;
 	}
 
+	/* swap button A with B and X with Y for Nintendo style controllers */
+	if ((xdata->quirks & XPADNEO_QUIRK_NINTENDO) && report->id == 1 && reportsize >= 17) {
+		data[14] = SWAP_BITS(data[14], 0, 1);
+		data[14] = SWAP_BITS(data[14], 2, 3);
+	}
+
 	if (report->id == 1 && reportsize == 55) {
 		/* XBE2: track the current controller profile */
 		xpadneo_switch_profile(xdata, data[35] & 0x03, false);
